#include <jni.h>
#include <string>
#include <cstdio>
#include <iostream>

extern "C" JNIEXPORT jstring JNICALL
Java_com_eastpolar_cli_NativeLib_stringFromJNI(
        JNIEnv *env,
        jobject /* this */) {
    std::string hello = "Hello from C++";
    return env->NewStringUTF(hello.c_str());
}

//纯c++，读取本地文件的方法，并且打印出来
extern "C"
JNIEXPORT _jbyteArray *JNICALL
readFile(JNIEnv *env,
         const char *filePath) {
    //获取log并用于打印
    jclass cls = env->FindClass("android/util/Log");
    jmethodID mid = env->GetStaticMethodID(cls, "i", "(Ljava/lang/String;Ljava/lang/String;)I");
    jstring tag = env->NewStringUTF("NativeLib");
    jstring msg = env->NewStringUTF(filePath);
    env->CallStaticIntMethod(cls, mid, tag, msg);

    FILE *file = fopen(filePath, "r");
    if (file == NULL) {
        return nullptr;
    }
    // 定位到文件末尾获取大小
    fseek(file, 0, SEEK_END);
    long size = ftell(file); // 使用 long 接收 ftell 的返回值
    printf("File size: %ld\n", size);
    rewind(file); // 将文件指针重新定位到文件开头

    std::string buffers; // 使用 std::string 来动态追加内容
    char buffer[1024];
    // 将所有的buffer写到一个对象中
    while (fgets(buffer, sizeof(buffer), file)) {
        printf("%s", buffer);
        buffers += buffer; // 使用 += 运算符追加内容
    }
    fclose(file);

    // 可选：打印或处理 buffers 中的全部内容
    std::cout << "File content: " << buffers << std::endl;
    env->CallStaticIntMethod(cls, mid, tag, env->NewStringUTF(buffers.c_str()));

    //将buffers写到内存中，并且返回地址内存中的byte地址
    jbyteArray byteArray = env->NewByteArray(buffers.size());
    env->SetByteArrayRegion(byteArray, 0, buffers.size(), (jbyte *) buffers.c_str());
    return byteArray;


}
